package com.tutorial.struts;

import java.util.Locale;
import javax.servlet.http.HttpSessionBindingListener;
import javax.servlet.http.HttpSessionBindingEvent;
import com.tutorial.struts.vo.UserVO;

// Almacena la informacin del usuario en su sesin.
// Implementa el interfaz HttpSessionBindingListener para que se le notifique
// el timeout y as pueda liberar los recursos de la sesin.
public class UserContainer implements HttpSessionBindingListener 
{
	// El carrito de la compra del usuario.
  	private Carrito cart = null;
  	//  Almacenamos la informacin del usuario.
  	private UserVO userVO = null;
  
	// Constructor por defecto.
	public UserContainer() 
  	{
	    super();
	    initialize();
  	}

	// El contenedor llama a este mtodo cuando se termina la sesin.
	public void valueUnbound(HttpSessionBindingEvent event) 
  	{
	    // Liberamos recursos de la sesin.
	    System.out.println( "Liberando sesin...");
	    cleanUp();
  	}

  	public Carrito getCart() 
  	{
	    return cart;
  	}

  	public void setCart(Carrito newCart) 
  	{
	    cart = newCart;
  	}

	// El contenedor llama a este mtodo cuando comienza la sesin.
	public void valueBound(HttpSessionBindingEvent event) 
  	{
  		// No hacemos nada por ahora ...
  	}

  	public UserVO getUserVO() 
  	{
	    return userVO;
  	}

  	public void setUserVO(UserVO newVO) 
  	{
	    userVO = newVO;
  	}

	// Inicializacin de los datos del usuario en sesin.
	private void initialize() 
  	{
	    // Create a new Shopping cart for this user
	    cart = new Carrito();
  	}

	// Liberamos recursos de la sesin.
	public void cleanUp() 
  	{
	    setUserVO(null);
	    cart = new Carrito();
  	}
}
